/*
 * rtunit-nxp - lpc176x.h
 *
 * NXP LPC176x registers description
 *
 * Copyright (C) 2017  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef LPC176X_H_INCLUDED
#define LPC176X_H_INCLUDED

#define SYSCON_BASE		0x400fc000
#define SYSCON_SCS		0x1a0
#define SYSCON_SCS_OSCRANGE	0x10
#define SYSCON_SCS_OSCEN	0x20
#define SYSCON_SCS_OSCSTAT	0x40
#define SYSCON_CLKSRCSEL	0x10c
#define SYSCON_CLKSRCSEL_IRC	0x00
#define SYSCON_CLKSRCSEL_MAIN	0x01
#define SYSCON_CLKSRCSEL_RTC	0x02
#define SYSCON_PLL0CON		0x080
#define  SYSCON_PLL0CON_PLLE0	0x01
#define  SYSCON_PLL0CON_PLLC0	0x02
#define SYSCON_PLL0CFG		0x084
#define SYSCON_PLL0CFG_M_SHIFT	0
#define SYSCON_PLL0CFG_N_SHIFT	16
#define SYSCON_PLL0STAT		0x088
#define  SYSCON_PLL0STAT_ESTAT	0x01000000
#define  SYSCON_PLL0STAT_CSTAT	0x02000000
#define  SYSCON_PLL0STAT_PLOCK0	0x04000000
#define SYSCON_PLL0FEED		0x08c
#define SYSCON_PLL1CON		0x0a0
#define SYSCON_PLL1CFG		0x0a4
#define SYSCON_PLL1STAT		0x0a8
#define SYSCON_PLL1FEED		0x0ac
#define SYSCON_CCLKCFG		0x104
#define SYSCON_USBCLKCFG	0x108
#define SYSCON_PCLKSEL0		0x1a8
#define  SYSCON_PCLKSEL0_UART0_SHIFT	6
#define  SYSCON_PCLKSEL0_UART1_SHIFT	8
#define SYSCON_PCLKSEL1		0x1ac
#define  SYSCON_PCLKSEL1_UART2_SHIFT	16
#define  SYSCON_PCLKSEL1_UART3_SHIFT	18
#define SYSCON_PCLKSEL_DIV4	0
#define SYSCON_PCLKSEL_DIV1	1
#define SYSCON_PCLKSEL_DIV2	2
#define SYSCON_PCLKSEL_DIV8	3
#define SYSCON_PCLKSEL_MASK	3

#define SYSCON_PCON		0x0c0
#define SYSCON_PCONP		0x0c4
#define  SYSCON_PCONP_PCUART2	0x01000000
#define  SYSCON_PCONP_PCUART3	0x02000000
#define  SYSCON_PCONP_PCQEI	0x00040000
#define SYSCON_CLKOUTCFG	0x0c8
#define SYSCON_FLASHCFG		0x0000
#define  SYSCON_FLASHCFG_A1	0x0000
#define  SYSCON_FLASHCFG_A2	0x0100
#define  SYSCON_FLASHCFG_A3	0x0200
#define  SYSCON_FLASHCFG_A4	0x0300
#define  SYSCON_FLASHCFG_A5	0x0400
#define  SYSCON_FLASHCFG_A6	0x0500
#define  SYSCON_FLASHCFG_AMASK	0x0f00


#define GPIO_BASE		0x2009c000
#define GPIO_FIODIR		0
#define GPIO_FIOMASK		0x10
#define GPIO_FIOPIN		0x14
#define GPIO_FIOSET		0x18
#define GPIO_FIOCLR		0x1c

#endif
