/*
 * grader-io - tty.c
 *
 * Copyright (C) 2016  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <kernel.h>
#include <tty.h>

void tty_set_ldisc(struct tty_struct *tty, const struct tty_ldisc_ops *ops,
		void *disc_data)
{
	unsigned long flags;

	local_irq_save(flags);
	tty->ldisc_ops = ops;
	tty->disc_data = disc_data;
	local_irq_restore(flags);
}
